
#ifndef _UTILS_H_
#define _UTILS_H_

#include <stdio.h>

#define isLeaf(x) (x->LChild == NULL)

#ifdef _MEM_INFO_
#define INC_MEM(x) \
          CurMemoryUse += (double)(x); \
          if (CurMemoryUse > MaxMemoryUse) \
            MaxMemoryUse = CurMemoryUse;

#define DEC_MEM(x) CurMemoryUse -= (double)(x);

#define ASSERT(x,y) \
          if (!(x)) { \
            printf("ERROR: "); \
            printf(y); \
            printf("\n"); \
            printf("Memory use: %.0f bytes\n", MaxMemoryUse); \
            exit(-1); \
          }
 
#define ASSERT2(x,y,z) \
          if (!(x)) { \
            printf("ERROR: "); \
            printf(y, z); \
            printf("\n"); \
            printf("Memory use: %.0f bytes\n", MaxMemoryUse); \
            exit(-1); \
          }
#else
#define ASSERT(x,y) \
          if (!(x)) { \
            printf("ERROR: "); \
            printf(y); \
            printf("\n"); \
            exit(-1); \
          }
 
#define ASSERT2(x,y,z) \
          if (!(x)) { \
            printf("ERROR: "); \
            printf(y, z); \
            printf("\n"); \
            exit(-1); \
          }
#endif

double Depth_ffact(double n);
double Depth_fchoose(double n, double m);
void Depth_DeleteList(TreeNodeList * node);
void Depth_DeleteTree(TreeNode * node);
void Depth_PrintMemUsage();
TreeNode * Depth_ReadInTree(FILE * fp, int useShortNames);
void Depth_PrintTree(TreeNode * node, int indent);

#endif
