
#ifndef _STRUCTS_H_
#define _STRUCTS_H_

struct _TreeNodeList;

typedef struct _LeftNode {
  double Samples;
  unsigned long FromLeft;
  struct _LeftNode * Next;
} LeftNode;

typedef struct _SizeNode {
  unsigned long SamSize;
  LeftNode * Left;
  struct _SizeNode * Next;
} SizeNode;

typedef struct _FarNode {
  unsigned long ID;
  SizeNode * Size;
  struct _FarNode * Next;
} FarNode;

typedef struct _CloseNode {
  unsigned long ID;
  FarNode * Far;
  struct _CloseNode * Next;
} CloseNode;

typedef struct _TreeNode {

  double depth;

  // Only for leaves
  unsigned long ID;

  char * Name;

  struct _TreeNode * LChild;
  struct _TreeNode * RChild;
  struct _TreeNode * Parent;

  struct _TreeNodeList * Descendents;
  
  struct _CloseNode * Close;

} TreeNode;

typedef struct _TreeNodeList {
  struct _TreeNode * Node;
  struct _TreeNodeList * Next;
} TreeNodeList;

typedef struct _InducedSubtree {

  double closeD, farD;
  double closeN, farN;

  TreeNode * Node;
  struct _InducedSubtree * Parent;
  struct _InducedSubtree * LChild;
  struct _InducedSubtree * RChild;

} InducedSubtree;  

#endif

