
#ifndef _UTILS_H_
#define _UTILS_H_

#include <stdio.h>
#include "structs.h"

#define isLeaf(x) (x->LChild == NULL)
#define ID_DEPTH(x) LeafArray[x]->depth
#define L_DEPTH(x) LeafArray[x->ID]->depth
#define ID(x) x->Node->ID
#define ISLEAF(x) x->Node->isLeaf
#define ISDESC(x,y) (x == numLeaves) ? 0 : \
          (y->Samples[x][x][0][1] > 0.0 || y->Samples[x][x][0][0] > 0.0)

#define INC_MEM(x) \
          CurMemoryUse += (double)(x); \
          if (CurMemoryUse > MaxMemoryUse) \
            MaxMemoryUse = CurMemoryUse;

#define DEC_MEM(x) CurMemoryUse -= (double)(x); 

#define ASSERT(x,y) \
          if (!(x)) { \
            printf("ERROR: "); \
            printf(y); \
            printf("\n"); \
            printf("Memory use: %.0f bytes\n", MaxMemoryUse); \
            exit(-1); \
          }

#define ASSERT2(x,y,z) \
          if (!(x)) { \
            printf("ERROR: "); \
            printf(y, z); \
            printf("\n"); \
            printf("Memory use: %.0f bytes\n", MaxMemoryUse); \
            exit(-1); \
          }

#define ASSERT3(x,y,z,w) \
          if (!(x)) { \
            printf("ERROR: "); \
            printf(y, z, w); \
            printf("\n"); \
            printf("Memory use: %.0f bytes\n", MaxMemoryUse); \
            exit(-1); \
          }

void Pairwise_PrepareAllNodes(TreeNode * node);
void Pairwise_DeleteTree(TreeNode * node);
void Pairwise_DeleteList(TreeNodeList * list);
TreeNode * Pairwise_ReadInTree(FILE * fp, int useShortNames);
double Pairwise_fchoose(double n, double m);
double Pairwise_fmin(double x, double y);
double Pairwise_fmax(double x, double y);

#endif
